unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeEngine, Series, ExtCtrls, TeeProcs, Chart, DbChart, StdCtrls,
  DB, ComCtrls, DBClient, Grids, DBGrids, ADODB;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    DBChart1: TDBChart;
    Series1: TBarSeries;
    ClientDataSet1: TClientDataSet;
    ClientDataSet1yearmon: TStringField;
    ClientDataSet1mon: TIntegerField;
    ClientDataSet1amt: TIntegerField;
    Button1: TButton;
    Label1: TLabel;
    Splitter1: TSplitter;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Series1AfterDrawValues(Sender: TObject);
    procedure ClientDataSet1AfterScroll(DataSet: TDataSet);
  private
    { Private declarations }
  public
    { Public declarations }
    AppendData : Boolean;
    CrossHairColor:TColor;
    CrossHairStyle:TPenStyle;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
var
  i : integer;
begin
  AppendData := True;
  Randomize;
  ClientDataSet1.Close;
  ClientDataSet1.CreateDataSet;
  for i := 1 to 12 do
    begin
      with ClientDataSet1 do
        begin
          Append;
          FieldByName('yearmon').AsString := '2004/'+ FormatFloat('00',i);
          FieldByName('mon').AsInteger := i;
          FieldByName('amt').AsInteger := (Random(100) + 100) * 100;
          Post;
        end;
    end;
  ClientDataSet1.First;
  AppendData := False;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  CrossHairColor := clYellow;
  CrossHairStyle := psSolid;
end;

procedure TForm1.Series1AfterDrawValues(Sender: TObject);
  Procedure DrawVerticalLine(AX,AY:Integer);
  begin
    with DBChart1,Canvas do
      begin
        Pen.Color := CrossHairColor;
        Pen.Style := CrossHairStyle;
        Pen.Mode:=pmXor;
        Pen.Width:=1;
        MoveTo(ax,ChartRect.Top - Height3D);
        LineTo(ax,ChartRect.Bottom - Height3D);
//        MoveTo(ChartRect.Left + Width3D,ay);
//        LineTo(ChartRect.Right + Width3D,ay);
    end;
  end;
var
   TmpX : Integer;
begin
  Try
    TmpX := Series1.CalcXPosValue(Series1.XValue[ClientDataSet1.RecNo - 1]);
    if PtInRect(DBChart1.ChartRect,Point(TmpX - DBChart1.Width3D,Round(DBChart1.Height / 2) + DBChart1.Height3D)) then
      DrawVerticalLine(TmpX,0);
    Label1.Caption := '';
  except
    Label1.Caption := 'Error - ' + IntTostr(ClientDataSet1.RecNo - 1);
  end;
end;

procedure TForm1.ClientDataSet1AfterScroll(DataSet: TDataSet);
begin
  if not AppendData then
    DBChart1.Repaint;
end;

end.
